<?php
/**
 * Omnisend Connection Error Notice View
 *
 * @package OmnisendPlugin
 */

defined( 'ABSPATH' ) || exit;

function display_connection_error_notice() {
	// phpcs:disable WordPress.Security.NonceVerification
	if ( empty( $_GET['error'] ) ) {
		return;
	}

	$code = sanitize_text_field( wp_unslash( $_GET['error'] ) );
	// phpcs:enable

	Omnisend_Plugin_Event::connection_event( Omnisend_Plugin_Event::CONNECTION_ERROR_NOTICE_SHOWN, $code );

	$error = new Omnisend_Connection_Error( $code );
	?>
	<div>
		<div class="omnisend-notice omnisend-notice-error">
			<div class="omnisend-notice-content-container">
				<img src="<?php echo esc_url( plugin_dir_url( __NAMESPACE__ ) ) . 'omnisend-connect/assets/img/warning_24.svg'; ?>">
				<div class="omnisend-notice-texts-container">
					<p>
						<?php
						echo wp_kses(
							$error->get_message(),
							array(
								'a' => array(
									'id'     => array(),
									'href'   => array(),
									'target' => array(),
								),
							)
						);
						?>
					</p>
				</div>
			</div>
		</div>
	</div>
	<?php
}
